#include <SoftwareSerial.h>
#include <NewPing.h>
#define IN1 3
#define IN2 5
#define IN3 10
#define IN4 11
#define TX 9
#define RX 8
#define PIN_TRIG 13
#define PIN_ECHO 12
int MAX_DISTANCE = 200;
int datchik = 0;
SoftwareSerial UNO(8, 9);
unsigned int distance;
NewPing sonar(PIN_TRIG, PIN_ECHO, MAX_DISTANCE);
// const byte rxPin = 2;
// const byte txPin = 3;
void forward(int power ){
    analogWrite(IN1, 0);
    analogWrite(IN2, power);
    analogWrite(IN3, 0);
    analogWrite(IN4, power);
}
void backward(int power ){
    analogWrite(IN1, power);
    analogWrite(IN2, 0);
    analogWrite(IN3, power);
    analogWrite(IN4, 0);
}
void right(int power ){
    analogWrite(IN1, 0);
    analogWrite(IN2, power);
    analogWrite(IN3, power);
    analogWrite(IN4, 0);
}
void left(int power ){
    analogWrite(IN1, power);
    analogWrite(IN2, 0);
    analogWrite(IN3, 0);
    analogWrite(IN4, power);
}
void stop_motors(){
    analogWrite(IN1, 0);
    analogWrite(IN2, 0);
    analogWrite(IN3, 0);
    analogWrite(IN4, 0);
}

void setup() {
  UNO.begin(9600);
  Serial.begin(9600);
  pinMode(IN1, OUTPUT);
  pinMode(IN2, OUTPUT);
  pinMode(IN3, OUTPUT);
  pinMode(IN4, OUTPUT);
  // pinMode(IN5, OUTPUT);
  


  distance = sonar.ping_cm();
  Serial.print(distance);
  Serial.println("см");
  while (distance < 15 ){
    Serial.print(distance);
    Serial.println("см");
    distance = sonar.ping_cm();
    delay(100);
  }
  while (distance > 15 ){
    datchik = analogRead(A0);
    Serial.println(datchik);
    Serial.print(distance);
    Serial.println("см");

    forward(160);

    delay(2000);

    distance = sonar.ping_cm();
  }
 
  Serial.print(distance);
  Serial.println("см");
  Serial.println("done");

  stop_motors();

  UNO.write("Ok");
  delay(500);
  
   distance = sonar.ping_cm();
  Serial.print(distance);
  Serial.println("см");

  while (distance < 25 ){
    Serial.print(distance);
    Serial.println("см");
    distance = sonar.ping_cm();
    delay(100);
  }
  while (distance < 60 ){
    datchik = analogRead(A0);
    Serial.println(datchik);
    Serial.print(distance);
    Serial.println("см");

    backward(160);

    delay(1000);
    while (distance < 55 ){
      left(100);
      delay(2000);
      UNO.write("Ok");
      delay(500);
      right(100);
      delay(2000);
      UNO.write("Ok");
      delay(500);
    }
    distance = sonar.ping_cm();

  }

}

void loop() {

}