import cv2
import math
import numpy
from paho.mqtt.subscribe import simple
from paho.mqtt.publish import single
import paho.mqtt.client as m
import time
def fmar(conturs,image):
    rect = cv2.minAreaRect(conturs)
    x,y = rect[0]
    cv2.circle(image,(int(x),int(y)),6,(0,0,255),-1)
    points = cv2.boxPoints(rect)
    point_int = numpy.array(points,int)
    cv2.drawContours(image,[point_int],-1,(255,0,0),3)
    return x,y

def read_values_from_file(filename):
    file = open(filename, 'r')
    values = file.read()
    values_split = values.split(',')
    for number in range(6):
        values_split[number] = int(values_split[number])
    file.close()
    return values_split
h = 0
cap = cv2.VideoCapture(0)
hostname = 'm9.wqtt.ru'
user_name = "u_JA38QM"
password = "XQAQsv4b"
port = 16922
topik1 = 'user_57fda11f/SIRENA1'
my_client = m.Client()
my_client.username_pw_set(user_name, password)
my_client.connect(hostname, port)
while True:
    isRead, image = cap.read()

    h_up_car, h_down_car, s_up_car, s_down_car, v_up_car, v_down_car = read_values_from_file('red_hsv.txt')

    HSV_up_car = [h_up_car, s_up_car, v_up_car]
    HSV_down_car = [h_down_car, s_down_car, v_down_car]

    np_HSV_up_car = numpy.array(HSV_up_car)
    np_HSV_down_car = numpy.array(HSV_down_car)

    image_hsv = cv2.cvtColor(image, cv2.COLOR_BGR2HSV_FULL)

    mask = cv2.inRange(image_hsv, np_HSV_down_car, np_HSV_up_car)

    conturs,cyrvis = cv2.findContours(mask,cv2.RETR_TREE,cv2.CHAIN_APPROX_NONE)

    for conturs in conturs:
        points_cont = len(conturs)
        if points_cont > 50 and h==0:
            fmar(conturs, image)
            my_client.publish(topik1,2)
    cv2.imshow('window', image)
    key = cv2.waitKey(20)
cap.release()